language Java {
  omit JavaLex.Omit;

  nonterminal {
    Java, CompilationUnit, PackageDeclaration, ImportDeclarations,
    ImportDeclaration, ImportName, TypeDeclarations, TypeDeclaration,
    InterfacesOpt, Interfaces, InterfaceTypeList, ClassType,
    InterfaceType, Modifiers, Modifier, ModifiersOpt,
    ClassDeclaration, SuperOpt, Super, ClassBody,
    ClassBodyDeclarations, ClassBodyDeclaration,
    ClassMemberDeclaration, StaticInitializer, InterfaceDeclaration,
    ExtendsInterfacesOpt, ExtendsInterfaces, ExtendsInterfacesRest,
    InterfaceBody, InterfaceMemberDeclarationsOpt,
    InterfaceMemberDeclarations, InterfaceMemberDeclaration,
    ConstantDeclaration, AbstractMethodDeclaration, FieldDeclaration,
    VariableDeclarators, VariableDeclarator, VariableDeclaratorId,
    VariableDeclaratorIdRest, VariableInitializer, ArrayInitializer,
    VariableInitializersOpt, VariableInitializers, MethodDeclaration,
    MethodHeader, MethodDeclarator, MethodDeclaratorRest, MethodBody,
    FormalParameterListOpt, FormalParameterList, FormalParameter,
    ThrowsOpt, Throws, ClassTypeList, ConstructorDeclaration,
    ConstructorDeclarator, ConstructorBody,
    ExplicitConstructorInvocationOpt, ExplicitConstructorInvocation,
    ConstructorModifier, Type, ReferenceType, ArrayTypeRest,
    PrimitiveType, NumericType, IntegralType, FloatingPointType,
    ResultType, Statement, LabeledStatement, Block, BlockStatements,
    BlockStatement, LocalVariableDeclaration,
    LocalVariableDeclarationRest, EmptyStatement, StatementExpression,
    SwitchStatement, SwitchBlocks, SwitchLabel, IfStatement,
    WhileStatement, DoStatement, ForStatement, ForInitOpt, ForInit,
    StatementExpressionList, ForUpdateOpt, ForUpdate, BreakStatement,
    ContinueStatement, ReturnStatement, ThrowStatement,
    SynchronizedStatement, TryStatement, Catchblock, ExpressionOpt,
    Expression, AssignmentOperator, ConditionalExpression,
    ConditionalOrExpression, ConditionalOrExpressionRest,
    ConditionalAndExpression, ConditionalAndExpressionRest,
    InclusiveOrExpression, InclusiveOrExpressionRest,
    ExclusiveOrExpression, ExclusiveOrExpressionRest, AndExpression,
    AndExpressionRest, EqualityExpression, EqualityExpressionRest,
    InstanceOfExpression, RelationalExpression,
    RelationalExpressionRest, ShiftExpression, ShiftExpressionRest,
    AdditiveExpression, AdditiveExpressionRest,
    MultiplicativeExpression, MultiplicativeExpressionRest,
    UnaryExpression, PreIncrementExpression, PreDecrementExpression,
    UnaryExpressionNotPlusMinus, PostfixExpression, CastExpression,
    PrimaryExpression, PrimaryExpressionRest, PrimaryPrefix,
    PrimarySuffix, Literal, BooleanLiteral, NullLiteral, Arguments,
    ArgumentList, AllocationExpression, ArrayDimsAndInits,
    ArrayDimsExpression, ArrayDims, Name, SimpleName, QualifiedName,
    IntegerLiteral;
  }

  Java[unit]                                       --> <CompilationUnit> [/] ;

  CompilationUnit[packagedecl]                     --> <PackageDeclaration> [/] <ImportDeclarations> [/] <TypeDeclarations> ;
                 [nopackagedecl]                   --> <ImportDeclarations> <TypeDeclarations> [] ;

  PackageDeclaration[package]                      --> package <Name> [] ";" [/] ;


  ImportDeclarations[declarations]                 --> <ImportDeclaration> <ImportDeclarations> [] ;
                    [empty]                        --> ;

  ImportDeclaration[import]                        --> import <ImportName> [] ";" [/] ;

  ImportName[identifierDot]                        --> <JavaLex.Identifier> [] . [] <ImportName> ;
	    [identifierDotStar]  	           --> <JavaLex.Identifier> [] . [] * ;
	    [identifier]		           --> <JavaLex.Identifier> ;

  TypeDeclarations[declarations]                   --> <TypeDeclaration> <TypeDeclarations> ;
                  [declaration]                    --> <TypeDeclaration> ;

  TypeDeclaration[class]                           --> <ClassDeclaration> ;
                 [interface]                       --> [<InterfaceDeclaration>] <InterfaceDeclaration> ;
                 [empty]                           --> ";" [/] ;

  InterfacesOpt[interfaces]                        --> <Interfaces> ;
               [empty]                             --> ;

  Interfaces[implements]                           --> implements <InterfaceTypeList> ;

  InterfaceTypeList[interfacetype]                 --> <InterfaceType> ;
                   [interfacetypes]                --> <InterfaceType> [] , <InterfaceTypeList> ;

  ClassType[classtype]                             --> <Name> ;

  InterfaceType[interfacetype]                     --> <Name> ;

  // -- Declaration: --------------------------------------------------

  Modifiers[modifiers]                             --> <Modifier> <Modifiers> ;
           [modifier]                              --> <Modifier> ;

  Modifier[public]                                 --> public ;
          [protected]                              --> protected ;
          [private]                                --> private ;
          [static]                                 --> static ;
          [abstract]                               --> abstract ;
          [final]                                  --> final ;
          [native]                                 --> native ;
          [synchronized]                           --> synchronized ;
          [transient]                              --> transient ;
          [volatile]                               --> volatile ;

  ConstructorModifier[public]                      --> public ;
		     [protected]                   --> protected ;
		     [private]	                   --> private ;
		     [empty]	                   --> ;

  ModifiersOpt[modifiers]                          --> <Modifiers> ;
              [empty]                              --> ;

  ClassDeclaration[class]                          --> <ModifiersOpt> class <JavaLex.Identifier> <SuperOpt> <Java.InterfacesOpt> <ClassBody> ;

  SuperOpt[super]                                  --> <Super> ;
          [empty]                                  --> ;

  Super[extendstype]                               --> extends <ClassType> ;

  ClassBody[classbody]                             --> { [+/] <ClassBodyDeclarations> [-/] } [/] ;

  ClassBodyDeclarations[declarations]              --> <ClassBodyDeclaration> [/] <ClassBodyDeclarations> ;
		       [empty]	                   --> ;

  ClassBodyDeclaration[staticinit]                 --> [<StaticInitializer>] <StaticInitializer> ;
		      [classdecl]                  --> [<ClassDeclaration>] <ClassDeclaration> ;
		      [interfacedecl]              --> [<InterfaceDeclaration>] <InterfaceDeclaration> ;
                      [constructordecl]            --> [<ConstructorDeclaratorAndDeclaration>]  <ConstructorDeclaration> ;
                      [memberdecl]                 --> <ClassMemberDeclaration> ;

  ClassMemberDeclaration[field]                    --> [<FieldDeclaration>] <FieldDeclaration> ;
  ClassMemberDeclaration[method]                   --> <MethodDeclaration> ;

  StaticInitializer[static]                        --> static <Block> ; 

  InterfaceDeclaration[interface]                  --> <ModifiersOpt> interface <JavaLex.Identifier> <ExtendsInterfacesOpt> <InterfaceBody> ;

  ExtendsInterfacesOpt[extendsinterfaces]          --> <ExtendsInterfaces> ;
                      [empty]                      --> ;

  ExtendsInterfaces[extendsinterfaces]             --> extends <Java.InterfaceType> <ExtendsInterfacesRest>;

  ExtendsInterfacesRest[extendrest]                --> , <Java.InterfaceType> <ExtendsInterfacesRest> ;
                       [empty]                     --> ;

  InterfaceBody[interfacebody]                     --> [/] { [+/] <InterfaceMemberDeclarationsOpt> [-/] } [/] ;

  InterfaceMemberDeclarationsOpt[declarations]     --> <InterfaceMemberDeclarations> ;
                                [empty]            --> ;

  InterfaceMemberDeclarations[declaration]         --> <InterfaceMemberDeclaration> [/] ;
                             [declarations]        --> <InterfaceMemberDeclaration> [/] <InterfaceMemberDeclarations> ;

  InterfaceMemberDeclaration[constant]             --> <ConstantDeclaration> ;
                            [abstractmethod]       --> [<AbstractMethodDeclaration>] <AbstractMethodDeclaration> ;

  ConstantDeclaration[field]                       --> <FieldDeclaration> ;

  AbstractMethodDeclaration[abstractmethod]        --> <ModifiersOpt> <MethodHeader> \; ;

  FieldDeclaration[fielddeclaration]               --> <ModifiersOpt> <Type> <VariableDeclarators> [] ";" ;

  VariableDeclarators[variabledeclarator]          --> <VariableDeclarator> ;
                     [variabledeclarators]         --> <VariableDeclarator> , <VariableDeclarators> ;

  VariableDeclarator[variabledeclarator]           --> <VariableDeclaratorId> ;
                    [initvariabledeclarator]       --> <VariableDeclaratorId> = <VariableInitializer> ;

  VariableDeclaratorId[variablearray]              --> <JavaLex.Identifier> [] <VariableDeclaratorIdRest>;
                      [variable]                   --> <JavaLex.Identifier> ;


  VariableDeclaratorIdRest[arrayrest]              --> "[" [] "]" [] <VariableDeclaratorIdRest> ;
                          [array]                  --> "[" [] "]" ;

  VariableInitializer[expression]                  --> <Expression> ;
                     [arrayinitializer]            --> <ArrayInitializer> ;

  ArrayInitializer[comma]                          --> { <VariableInitializersOpt> , } ;
                  [nocomma]                        --> { <VariableInitializersOpt> } ;

  VariableInitializersOpt[variableinitialisers]    --> <VariableInitializers> ;
                         [empty]                   --> ;

  VariableInitializers[VariableInitializer]        --> <VariableInitializer> ;
                      [VariableInitializercomma]   --> <VariableInitializer> , ;
                      [VariableInitializers]       --> <VariableInitializer> , <VariableInitializers> ;

  MethodDeclaration[methoddeclaration]             --> <MethodHeader> <MethodBody> [/] ;

  MethodHeader[methodheader]                       --> <ModifiersOpt> <ResultType> <MethodDeclarator> <ThrowsOpt> ;

  MethodDeclarator[methoddeclarator]               --> <JavaLex.Identifier> [] ( [] <FormalParameterListOpt> [] ) ;
                  [methoddeclaratorrest]           --> <JavaLex.Identifier> ( [] <FormalParameterListOpt> [] ) [] <MethodDeclaratorRest>;

  MethodDeclaratorRest[rest]                       --> "[" [] "]" [] <MethodDeclaratorRest> ;
                      [norest]                     --> "[" "]" ;

  MethodBody[block]                                --> <Block> ;
            [semicolon]                            --> \; ;

  FormalParameterListOpt[formalparameterlist]      --> <FormalParameterList> ;
                        [empty]                    --> ;

  FormalParameterList[formalparameter]             --> <FormalParameter> ;
                     [formalparameters]            --> <FormalParameter> , <FormalParameterList> ;

  FormalParameter[formalparameter]                 --> <Type> <VariableDeclaratorId> ;

  ThrowsOpt[throws]                                --> <Throws> ;
           [empty]                                 --> ;

  Throws[throws]                                   --> throws <ClassTypeList> ;

  ClassTypeList[classtype]                         --> <Java.ClassType> ;
               [classtypes]                        --> <Java.ClassType> , <ClassTypeList> ;


  ConstructorDeclaration[constructordeclaration]   --> <ConstructorModifier> <ConstructorDeclarator> <ThrowsOpt> <ConstructorBody> ;

  ConstructorDeclarator[constructordeclarator]     --> <SimpleName> ( <FormalParameterListOpt> ) ;

  ConstructorBody[constructorbody]                 --> { [+/] <ExplicitConstructorInvocationOpt> <BlockStatements> [-/] } ;

  ExplicitConstructorInvocationOpt[explicit]       --> [<ExplicitConstructorInvocation>] <ExplicitConstructorInvocation> ;
                                  [empty]          --> ;

  ExplicitConstructorInvocation[this]              --> this [] <Arguments> \; [/] ;
                               [super]             --> super [] <Arguments> \; [/] ;


  // -- Type: --------------------------------------------------

  Type[primitivetype]                              --> <PrimitiveType> ;
      [referencetype]                              --> <ReferenceType> ;

  ReferenceType[primitivetypearray]                --> <PrimitiveType> <ArrayTypeRest> ;
               [namearray]                         --> <Name> <ArrayTypeRest> ;

  ArrayTypeRest[arrayrest]                         --> "[" [] "]" <ArrayTypeRest> ;
               [empty]                             --> ;

  PrimitiveType[numerictype]                       --> <NumericType> ;
               [boolean]                           --> boolean ;

  NumericType[integral]                            --> <IntegralType> ;
             [floatinpoint]                        --> <FloatingPointType> ;

  IntegralType[byte]                               --> byte ;
              [short]                              --> short ;
              [int]                                --> int ;
              [long]                               --> long ;
              [char]                               --> char ;

  FloatingPointType[float]                         --> float ;
                   [double]                        --> double ;

  ResultType[void]                                 --> void ;
            [type]                                 --> <Type> ;

  // -- Statement: --------------------------------------------------

  Statement[label]                                 --> [<LabeledStatement>] <LabeledStatement> ;
           [block]                                 --> <Block> ;
           [empty]                                 --> <EmptyStatement> ;
           [expression]                            --> <StatementExpression> [] ";" ;
           [switch]                                --> <SwitchStatement> ;
           [if]                                    --> <IfStatement> ;
           [while]                                 --> <WhileStatement> ;
           [do]                                    --> <DoStatement> ;
           [for]                                   --> <ForStatement> ;
           [break]                                 --> <BreakStatement> ;
           [continue]                              --> <ContinueStatement> ;
           [return]                                --> <ReturnStatement> ;
           [throw]                                 --> <ThrowStatement> ;
           //[synchronized]                          --> <SynchronizedStatement> ;
           [try]                                   --> <TryStatement> ;

  LabeledStatement[labeled]                        --> <JavaLex.Identifier> : <Statement> ;

  Block[block]                                     --> { [+/] <BlockStatements> [-/] } ;

  BlockStatements[block]                           --> <BlockStatement> [/] <BlockStatements> ;
		 [trap]      			   --> [<CaseTrap>] ;
                 [empty]                           --> ;

  BlockStatement[variabledeclaration]              --> [<LocalVariableDeclaration>] <LocalVariableDeclaration> [] ";" ;
                [statement]                        --> <Statement>  ;
                [classdeclaration]                 --> <ClassDeclaration>  ;

  LocalVariableDeclaration[final]                  --> final <Type> <VariableDeclarator> <LocalVariableDeclarationRest> ;
                          [notfinal]               --> <Type> <VariableDeclarator> <LocalVariableDeclarationRest> ;

  LocalVariableDeclarationRest[rest]               --> , <VariableDeclarator> [] <LocalVariableDeclarationRest> ;
                              [empty]              --> ;

  EmptyStatement[emptystatement]                   --> \; ;

  StatementExpression[preincrementexpression]      --> <PreIncrementExpression> ;
                     [predecrementexpression]      --> <PreDecrementExpression> ;
                     [primaryexpression]           --> <PrimaryExpression> ;
                     [plusplus]                    --> <PrimaryExpression> [] ++ ;
                     [minusminus]                  --> <PrimaryExpression> [] -- ;
                     [assignment]                  --> <PrimaryExpression> <AssignmentOperator> <Expression> ;
	
  SwitchStatement[switch]                          --> switch ( <Expression> ) { <SwitchBlocks> } ;

  SwitchBlocks[label]                              --> <SwitchLabel> <BlockStatements> <SwitchBlocks> ;
	      [empty]    			   --> ;

  SwitchLabel[case]                                --> case <Expression> : ;
             [default]                             --> default : ;

  IfStatement[ifelse]                              --> if ( [] <Expression> [] ) <Statement> else [+] <Statement> [-] ;
             [if]                                  --> if ( [] <Expression> [] ) <Statement> ;

  WhileStatement[while]                            --> while ( [] <Expression> [] ) <Statement> ;

  DoStatement[do]                                  --> do <Statement> while ( <Expression> ) \; [/] ;

  ForStatement[for]                                --> for ( [] <ForInitOpt> [] ";" <ExpressionOpt> [] ";" <ForUpdateOpt> [] ) <Statement> ;

  ForInitOpt[forinit]                              --> <ForInit> ;
            [empty]                                --> ;

  ForInit[localvariabledeclaration]                --> [<LocalVariableDeclaration>] <LocalVariableDeclaration> ;
         [statementexpression]                     --> <StatementExpressionList> ;

  StatementExpressionList[expressions]             --> <StatementExpression> , <StatementExpressionList> ;
                         [expression]              --> <StatementExpression> ;

  ForUpdateOpt[forupdate]                          --> <ForUpdate> ;
              [empty]                              --> ;

  ForUpdate[statementexpressions]                  --> <StatementExpressionList> ;

  BreakStatement[breakidentifier]                  --> break <JavaLex.Identifier> [] ";" [/] ;
                [break]                            --> break [] ";" [/] ;

  ContinueStatement[continueidentifier]            --> continue <JavaLex.Identifier> [] ";" [/] ;
                   [continue]                      --> continue [] ";" [/] ;

  ReturnStatement[returnexpression]                --> return <Expression> [] ";" [/] ;
                 [return]                          --> return [] ";" [/] ;

  ThrowStatement[throw]                            --> throw <Expression> \; ;

  SynchronizedStatement[synchronized]              --> synchronized ( <Expression> ) <Block> ;

  TryStatement[tryfinally]                         --> try <Block> <Catchblock> finally <Block> ;
              [try]                                --> try <Block> [/] <Catchblock> ;

  Catchblock[catch]                                --> catch ( [] <FormalParameter> [] ) <Block> <Catchblock> ;
            [empty]                                --> ;


  // -- Expression: --------------------------------------------------

  ExpressionOpt[expression]                        --> <Expression> ;
               [empty]                             --> ;

  Expression[conditionalexpression]                --> <ConditionalExpression> ;
            [assignment]                           --> <ConditionalExpression> <AssignmentOperator> <Expression> ;

  AssignmentOperator                               --> "=" ;
                                                   --> "*=" ;
                                                   --> "/=" ;
                                                   --> "%=" ;
                                                   --> "+=" ;
                                                   --> "-=" ;
                                                   --> \<\<= ;
                                                   --> \>\>= ;
                                                   --> \>\>\>= ;
                                                   --> "&=" ;
                                                   --> "^=" ;
                                                   --> "|=" ;

  ConditionalExpression[ifexpression]              --> <ConditionalOrExpression> ? <Expression> : <ConditionalExpression> ;
                       [conditionalorexpression]   --> <ConditionalOrExpression> ;

  ConditionalOrExpression[expression]              --> <ConditionalAndExpression> <ConditionalOrExpressionRest> ;

  ConditionalOrExpressionRest[rest]                --> || <ConditionalAndExpression> <ConditionalOrExpressionRest> ;
                             [empty]               --> ;

  ConditionalAndExpression[expression]             --> <InclusiveOrExpression> <ConditionalAndExpressionRest> ;

  ConditionalAndExpressionRest[rest]               --> && <InclusiveOrExpression> <ConditionalAndExpressionRest> ;
                              [empty]              --> ;

  InclusiveOrExpression[expression]                --> <ExclusiveOrExpression> <InclusiveOrExpressionRest> ;

  InclusiveOrExpressionRest[expression]            --> "|" <ExclusiveOrExpression> <InclusiveOrExpressionRest> ;
                           [trap]                  --> [ <OrOrTrap> ] ;
                           [empty]                 --> ;

  ExclusiveOrExpression[expression]                --> <AndExpression> <ExclusiveOrExpressionRest> ;

  ExclusiveOrExpressionRest[rest]                  --> ^ <AndExpression> <ExclusiveOrExpressionRest> ;
                           [empty]                 --> ;

  AndExpression[expression]                        --> <EqualityExpression> <AndExpressionRest> ;

  AndExpressionRest[rest]                          --> & <EqualityExpression> <AndExpressionRest> ;
                   [trap]                          --> [ <AndAndTrap> ] ;
                   [expty]                         --> ;

  EqualityExpression[expression]                   --> <InstanceOfExpression> <EqualityExpressionRest> ;

  EqualityExpressionRest[equalrest]                --> == <InstanceOfExpression> <EqualityExpressionRest> ;
                        [notequalrest]             --> != <InstanceOfExpression> <EqualityExpressionRest> ;
                        [empty]                    --> ;

  InstanceOfExpression[instanceof]                 --> <RelationalExpression> instanceof <Type> ;
                      [expression]                 --> <RelationalExpression> ;

  RelationalExpression[expression]                 --> <ShiftExpression> <RelationalExpressionRest> ;

  RelationalExpressionRest[less]                   --> \< <ShiftExpression> <RelationalExpressionRest> ;
                          [greater]                --> \> <ShiftExpression> <RelationalExpressionRest> ;
                          [lessequal]              --> \<= <ShiftExpression> <RelationalExpressionRest> ;
                          [greaterequal]           --> \>= <ShiftExpression> <RelationalExpressionRest> ;
                          [empty]                  --> ;

  ShiftExpression[expression]                      --> <AdditiveExpression> <ShiftExpressionRest> ;

  ShiftExpressionRest[leftshift]                   --> "<<" <AdditiveExpression> <ShiftExpressionRest> ;
                     [rightshift]                  --> ">>" <AdditiveExpression> <ShiftExpressionRest> ;
                     [rightshiftzero]              --> ">>>" <AdditiveExpression> <ShiftExpressionRest> ;
                     [empty]                       --> ;

  AdditiveExpression[expression]                   --> <MultiplicativeExpression> <AdditiveExpressionRest> ;

  AdditiveExpressionRest[plus]                     --> + <MultiplicativeExpression> <AdditiveExpressionRest> ;
                        [minus]                    --> - <MultiplicativeExpression> <AdditiveExpressionRest> ;
                        [empty]                    --> ;

  MultiplicativeExpression[expression]             --> <UnaryExpression> <MultiplicativeExpressionRest> ;

  MultiplicativeExpressionRest[multi]              --> * <UnaryExpression> <MultiplicativeExpressionRest> ;
                              [division]           --> / <UnaryExpression> <MultiplicativeExpressionRest> ;
                              [remainder]          --> % <UnaryExpression> <MultiplicativeExpressionRest> ;
                              [empty]              --> ;

  UnaryExpression[plus]                            --> + <UnaryExpression> ;
                 [minus]                           --> - <UnaryExpression> ;
                 [preincrement]                    --> <PreIncrementExpression> ;
                 [predecrement]                    --> <PreDecrementExpression> ;
                 [expression]                      --> <UnaryExpressionNotPlusMinus> ;

  PreIncrementExpression[plusplus]                 --> ++ [] <PrimaryExpression> ;

  PreDecrementExpression[minusminus]               --> -- [] <PrimaryExpression> ;

  UnaryExpressionNotPlusMinus[bitwise]             --> ~ [] <UnaryExpression> ;
                             [logical]             --> ! [] <UnaryExpression> ;
                             [cast]                --> [<CastExpression>] <CastExpression> ;
                             [postfix]             --> <PostfixExpression> ;

  PostfixExpression[plusplus]                      --> <PrimaryExpression> ++ ;
                   [minusminus]                    --> <PrimaryExpression> -- ;
                   [expression]                    --> <PrimaryExpression> ;

  CastExpression[cast]                             --> ( [] <Type> [] ) <UnaryExpression> ;
                [castnotplusminus]                 --> ( [] <Type> [] ) <UnaryExpressionNotPlusMinus> ;

  PrimaryExpression[expression]                    --> <PrimaryPrefix> <PrimaryExpressionRest> ;

  PrimaryExpressionRest[rest]                      --> [] <PrimarySuffix> <PrimaryExpressionRest> ;
                       [empty]                     --> ;

  PrimaryPrefix[literal]                           --> <Literal> ;
               [this]                              --> this ;
               [super]                             --> super [] . [] <JavaLex.Identifier> ;
               [expresion]                         --> ( [] <Expression> [] ) ;
               [accocation]                        --> <AllocationExpression> ;
               [resulttypedotclass]                --> [<ResultTypeDotClass>] <ResultType> [] . [] class ;
               [name]                              --> <Name> ;


  PrimarySuffix[dotthis]                           --> .this ;
               [dotallocation]                     --> [] . []  <AllocationExpression> ;
               [expression]                        --> "[" [] <Expression> [] "]" ;
               [dotidentifier]                     --> [] . [] <JavaLex.Identifier> ;
               [arguments]                         --> <Arguments> ;

  Literal[integerliteral]                          --> <IntegerLiteral> ;
         [floatingpointliteral]                    --> <JavaLex.FloatingPointLiteral> ;
         [characterliteral]                        --> <JavaLex.CharacterLiteral> ;
         [stringliteral]                           --> <JavaLex.StringLiteral> ;
         [booleanliteral]                          --> <BooleanLiteral> ;
         [nullliteral]                             --> <NullLiteral> ;

  BooleanLiteral[true]                             --> true ;
                [false]                            --> false ;

  NullLiteral[null]                                --> null ;

  Arguments[argumentlist]                          --> ( [] <ArgumentList> [] ) ;
           [emptyargumentlist]                     --> ( [] ) ;

  ArgumentList[expressions]                        --> <Expression> [] , <ArgumentList> ;
              [expression]                         --> <Expression> ;


  AllocationExpression[primitivetype]              --> new <PrimitiveType> [] <ArrayDimsAndInits> ;
                      [arraydimsandinits]          --> new <Name> [] <ArrayDimsAndInits> ;
                      [argumentsclassbody]         --> new <Name> [] <Arguments> <ClassBody> ;
                      [arguments]                  --> new <Name> [] <Arguments> ;

  ArrayDimsAndInits[arraydimsexpressions]          --> <ArrayDimsExpression> <ArrayDims> ;
                   [arraydimsexpression]           --> <ArrayDimsExpression> ;
                   [arraydimsinitializer]          --> [<ArrayDimsAndInitializer>] <ArrayDims> <ArrayInitializer> ;

  ArrayDimsExpression[expressions]                 --> "[" [] <Expression> [] "]" [] <ArrayDimsExpression> ;
                     [expression]                  --> "[" [] <Expression> [] "]" ;

  ArrayDims[arraydims]                             --> "[" "]" <ArrayDims> ;
           [empty]                                 --> ;

  // -- Identifier: --------------------------------------------------

  Name[name]                                       --> <SimpleName> <QualifiedName> ;

  SimpleName[simplename]                           --> <JavaLex.Identifier> ;

  QualifiedName[qualifiedname]                     --> [] . [] <JavaLex.Identifier> <QualifiedName> ;
               [empty]                             --> ;


  IntegerLiteral[decimalliteral]	           --> <JavaLex.DecimalLiteral> ;
		[hexliteral]			   --> <JavaLex.HexLiteral> ;
		[octalliteral]			   --> <JavaLex.OctalLiteral> ;


  // -- Traps and Guards: --------------------------------------------

  nonterminal {
    CaseTrap, AndAndTrap, OrOrTrap, ResultTypeDotClass, ArrayDimsAndInitializer, 
    ConstructorDeclaratorAndDeclaration;
  }

  ArrayDimsAndInitializer[guard]                   --> <ArrayDims> <ArrayInitializer> ;

  ConstructorDeclaratorAndDeclaration[guard]       --> <ConstructorModifier> <ConstructorDeclaration> ;

  ResultTypeDotClass[guard]  	                   --> <ResultType> [] . [] class ;

  CaseTrap[trap]	   	                   --> case ;

  AndAndTrap[trap]                                 --> && ;

  OrOrTrap[trap]                                    --> || ;
}
